import sift
import struct
import subprocess
import os
import pickle
import ConfigParser, xml.dom.minidom
from xml.dom.minidom import Node
import time
import shutil



def remap(opath,newbasepath,oldbasepath):
	"takes opath, removes oldbasepath, and replaces it with newbasepath"
	
	start = opath.find(oldbasepath)
	if start>-1:
		newpath = opath[0:start]+newbasepath+opath[start+len(oldbasepath):]
		return newpath
	else:
		return ""
	
def readData(mode = "ALL",splitExt= None): 
	"Returns clsList,testpath,resultpath,workpath \012 clsList[i][0] is the classname, clsList[i][1] is working path, and  clsList[i][2] is the list of images for this class "
#if __name__ == "__main__":

	#This Section reads in the datafile which specifies where the training data is
	if mode=="ALL":
		TRAIN = True
		TEST = True
	elif mode == "TEST":
		TRAIN = False
		TEST = True
	elif mode == "TRAIN":
		TRAIN = True
		TEST = False
	config = ConfigParser.ConfigParser()
	config.readfp(open('config.ini'))
	
	testpath = os.path.normpath(config.get('Directories','testpath'))
	workpath = os.path.normpath(config.get('Directories','workpath'))
	
	resultpath = os.path.normpath(config.get('Directories','resultpath'))
	
	REMOVE_IMAGES = (config.get("Modes",'REMOVE_IMAGES') == 'True')
	
	if TEST & REMOVE_IMAGES:
		#if os.path.exists(os.path.join(testpath,'done')):
		#	os.remove(os.path.join(testpath,'done'))
		if os.path.exists(resultpath):
			shutil.rmtree(resultpath)
		if os.path.exists(workpath):
			shutil.rmtree(workpath)
		
	if (not os.path.exists(workpath)):
		os.makedirs(workpath)
	if (not os.path.exists(resultpath)):
		os.makedirs(resultpath)
	
	
	
	REMAP = (config.get("Modes",'REMAP') == 'True')

	WAIT_ON_WEB = (config.get("Modes",'WAIT_ON_WEB') == 'True')
	
	if REMAP:
		oldpath = os.path.normpath(config.get('Directories','oldpath'))
		newpath = os.path.normpath(config.get('Directories','newpath'))
	if WAIT_ON_WEB & TRAIN: #can't wait for web in test
		webwaitfile = os.path.normpath(config.get('Files','webwaitfile'))
		count =0
		print webwaitfile
		while not os.path.isfile(webwaitfile):
			count = count+1
			print webwaitfile, " "+str(count)

			time.sleep(1)
		if os.path.exists(newpath):
			shutil.rmtree(newpath)
			#os.makedirs(newpath)
		shutil.copytree(os.path.split(webwaitfile)[0],newpath)
	
	datafile = os.path.normpath(config.get("Files","datafile"))
	print datafile
	doc = xml.dom.minidom.parse(datafile)
	
	if ( not os.path.exists(workpath) ) :
		os.mkdir(workpath)
	clsList = []
	imgList = []
	
	webresultpath = os.path.normpath(config.get("Directories","webresultpath"))
	trainData = os.path.normpath(config.get('Files','traindata'))
	
	USE_SAVED = (not TRAIN) #os.path.exists(trainData)


	if USE_SAVED:
		if splitExt == None:
			fp = open(trainData,'r')
			clsList = pickle.load(fp)
		else:
			fp = open(trainData+splitExt,'r')
			clsList = pickle.load(fp)
	else:	
		for index,node in enumerate(doc.getElementsByTagName("class")):
			imgList = []
			cls = node.getAttribute("name")
			#clsList.append(cls)
			clspath = os.path.join(workpath,cls)
			if (not os.path.exists(clspath)):
				os.mkdir(clspath)
			
			for imageNode in node.childNodes: 	
				if imageNode.nodeType != Node.TEXT_NODE: #I have no idea what this is for
					impath = imageNode.getAttribute("path")
					quality = imageNode.getAttribute("quality")
					if len(quality) == 0:
						quality = -1
					if REMAP:
						impath = remap(impath,newpath,oldpath)
					image = sift.Datum(impath, imageNode.getAttribute("source"), float(quality))
					imgList.append(image)
			clsList.append([cls,clspath,imgList,index])


	datadict= {'clsList': clsList, 'testpath':testpath,'resultpath':resultpath,'workpath':workpath,'traindata': trainData, 'webresultpath':webresultpath}

	return datadict
	#(clsList,testpath,resultpath,workpath)
	
	#fp = open("mytest","w")
	#pickle.dump(clsList,fp)
	#fp.close()

def loadImagesFromXML(xmlFilename,oldpath=None,newpath=None):
	print datafile
	doc = xml.dom.minidom.parse(xmlFilename)

	clsList=[]
	for index,node in enumerate(doc.getElementsByTagName("class")):
		imgList = []
		cls = node.getAttribute("name")
		

		for imageNode in node.childNodes: 	
			if imageNode.nodeType != Node.TEXT_NODE: #I have no idea what this is for
				impath = imageNode.getAttribute("path")
				quality = imageNode.getAttribute("quality")
				if len(quality) == 0:
					quality = -1
				if oldpath!=None:
					impath = remap(impath,newpath,oldpath)
				image = sift.Datum(impath, imageNode.getAttribute("source"), float(quality))
				imgList.append(image)
		clsList.append([cls,clspath,imgList,index])
	return clsList
