import os
import time
from numpy import *
class FileWatcher:
	'Watches a directory, and provides the ability to return new files of certain filetypes'
	def __init__(self,directory,filetypes = None,quitFile = None):
		self.directory = directory
		if filetypes!=None:
		
			self.filetypes = [file.lower() for file in filetypes]
		else:
			self.filetypes = None
		self.lasttime = os.path.getmtime(directory)
		self.lastlength = None
		self.isFirst = True
		self.quitFile = quitFile
	def getContents(self):
		'Returns all the contents of self.directory'
		tmpfiles = os.listdir(self.directory)
		self.lasttime = time.time() #os.path.getmtime(self.directory)
		files = []
		for f in tmpfiles:
			junk,ext = os.path.splitext(f)	
			
			if self.filetypes==None:
				files.append(os.path.join(self.directory,f))
			elif any([ext.lower() == filetype for filetype in self.filetypes]):
				
				files.append(os.path.join(self.directory,f))
		return files
	def isDone(self):
		
		return os.path.exists(self.quitFile)
			
	def getNewContent(self,readAllOnFirst = False):
		'Returns files of a certain file type since last call'
		
		if readAllOnFirst & self.isFirst:
			self.isFirst = False
			return self.getContents()
		files=[]

		listdir = os.listdir(self.directory)
		thistime = time.time()
		#print listdir,len(listdir), self.lastlength,self.lasttime,thistime
		
		if self.lastlength<len(listdir):
			cwd = os.getcwd()
			os.chdir(self.directory)
			for f in listdir:
				#print f,os.path.getctime(f),
				if (os.path.getctime(f)>self.lasttime) & (os.path.getctime(f)<=thistime):
					
					junk,ext = os.path.splitext(f)
					if self.filetypes==None:
						files.append(os.path.join(self.directory,f))
					elif any([ext.lower() == filetype for filetype in self.filetypes]):
						files.append(os.path.join(self.directory,f))
		
			self.lastlength = len(listdir)
			self.lasttime = thistime
			os.chdir(cwd)
		return files

class MyRect:
	def __init__(self,points=None,transform = None,rect = None):
		self.transform = transform
		if rect!=None:
			self.plist = rect.plist
			if transform==None:
				self.transform = rect.transform
		else:
			self.plist = points

	def setTransform(self,transform):
		self.transform = transform
	def asRectangle(self):
		tlist =self.transform.transform(self.plist)	
		
		left,top = amin(tlist,axis=0)
		width,height = amax(tlist,axis=0)- amin(tlist,axis=0)
		return (left,top,width,height)
	def tostr(self):
		if self.transform != None:
			tlist = self.transform.transform(self.plist)
		else:
			tlist = array(self.plist)
		print tlist
	def Contains(self,x):
		if self.transform != None:
			tlist = self.transform.transform(self.plist)
		else:
			tlist = array(self.plist)
		maxx = amax(tlist,axis=0)
		minx = amin(tlist,axis=0)
		return ((minx<x) & (x<maxx)).all(axis=1)


if __name__=="__main__":
	myFileWatcher = FileWatcher('/home/shelmer/Working/SRVC/ImageMatching/Python/Test',['.jpg'])
	
	print myFileWatcher.getContents()
	
	for i in range(5):
		time.sleep(8)
		print myFileWatcher.getNewContent()