module console.commands.ComputeGTCommand;

import console.commands.GenericCommand;
import console.commands.DefaultCommand;
import dataset.ComputeGroundTruth;
import util.Logger;
import util.defines;

static this() {
 	register_command!(ComputeGTCommand);
}

class ComputeGTCommand : DefaultCommand
{
	public static string NAME = "compute_gt";
	string inputFile;
	string testFile;
	string matchFile;
	uint skip;
	uint nn;
	bool byteFeatures;
	
	this(string name) 
	{
		super(name);
		register(inputFile,"i","input-file", "","Input dataset file.");
		register(testFile,"t","test-file", "","Test dataset file (if not present, generated by sampling from the imput dataset.");
 		register(matchFile,"m","match-file", "", "Match file to be generated.");
 		register(skip,"K","skip", 0, "Skip the first k matches.");
 		register(nn,"n","nn", 1, "How many NN to compute (default 1).");
 		register(byteFeatures,"B","byte-features", 0, "Use byte sized feature elements.");
 		
 		description = "Computes the ground-truth given an input dataset and a test dataset. If test dataset is not present it is"
 					" sampled form the input dataset";
	}
	
	
	void executeWithType(T)()
	{
		compute_gt!(T)(inputFile, testFile, matchFile, nn, skip);
	}
	
	void execute() 
	{
		if (byteFeatures) {
			executeWithType!(ubyte)();
		} else {
			executeWithType!(float)();
		}		
	}
	

	
}