import sys, os, glob, re
"""
Creates symbolic links without the gcc version string to the versioned
library locations.

(eg. libboost_filesystem-mt.so -> libboost_filesystem-gcc42-mt.so)

This is just to allow simpler makefiles that will work across several
systems.

The argument is the libpath (eg. /usr/local/lib) May have to be ran as
root.
"""

libpath = sys.argv[1]

libs = glob.glob(os.path.join(libpath, 'libboost_*gcc??-mt.so'))
for lib in libs:
    link = re.sub('gcc+([0-9][0-9])-', '', lib)
    print 'linking %s -> %s' % (link, lib)
    os.symlink(lib, link)
