#pragma once

#include <map>
#include <utility>
#include <boost/numeric/ublas/vector.hpp>

namespace sjm { namespace histograms {
  
  typedef std::pair<int, int> Coordinate;
  
  namespace detail {
    struct coordinateComparison
    {
      bool operator()(const Coordinate & a, const Coordinate & b) const
      {
	return (a.first < b.first or (a.first == b.first and a.second < b.second));
      }
    };
  }
  
  typedef std::map<std::pair<int, int>, boost::numeric::ublas::vector<float>, detail::coordinateComparison > IntegralHistogram;
}}
