import sift_ext

params = sift_ext.SiftParameters()
# SiftParameters has the following options
## rotationInvariance
## octaveSteps: number of rescalings per doubling of scale space
## noNormalize: if the pre-normalization sift descriptor has magnitude less than this, it is not normalized (0.5 seems to get rid of a lot of noise)
## discard: if this is true, those non-normalized sift descriptors are also discarded, if false, a 128-d zero-vector is returned
params.octaveSteps = 3
params.noNormalize = 0.5
params.discard = True
params.rotationInvariance = False

extractor = sift_ext.SiftExtractor(params)
extractor.loadImage("../../TestImages/seminar.pgm")
extractor.buildScalePyramid()

print extractor.scaleRange(0,100)
print extractor.scaleRange(10, 30)
print extractor.scaleRange(15,10)
print extractor.scaleRange(0,8)
print extractor.scaleRange(0,16)
print extractor.scaleRange(0,32)

for x in range(250, 280, 5):
  d = extractor.getDescriptor(x, 300, 0)
  print d
  print '\n'
