#pragma once

#include <vector>
#include <boost/multi_index_container.hpp>
#include <boost/multi_index/ordered_index.hpp>
#include <boost/multi_index/member.hpp>

namespace sjm { namespace SpatialPyramid {
  /*! Codeword id along with location and scale
   */
  struct LocatedCodeword
  {
    int id; ///< Codeword id
    float x; ///< x-location
    float y; ///< y-location
    float scale; ///< scale that this codeword was found at
  };
  
  //typedef std::vector<LocatedCodeword> CodewordSet; ///< A collection of codewords

  typedef boost::multi_index_container<
    LocatedCodeword,
    boost::multi_index::indexed_by<
    boost::multi_index::ordered_non_unique<boost::multi_index::member<LocatedCodeword,float,&LocatedCodeword::x> >,
    boost::multi_index::ordered_non_unique<boost::multi_index::member<LocatedCodeword,float,&LocatedCodeword::y> >
  >
  > CodewordSet;
}}
    
