function newfilename = change_extension(filename, newextension)
% changes or adds an extension to a filename
%
% CHANGE_EXTENSION(FILENAME, NEWEXTENSION) returns a string that is
% the FILENAME with its original extension replaced with the NEWEXTENSION
% or if FILENAME did not have an extension a string with the NEWEXTENSION
% appeneded. NEWEXTENSION must include the '.' of the extension.

[pathstr, name, ext, versn] = fileparts(filename);
newfilename = fullfile(pathstr,[name newextension versn]);

end