% Reads all configuration files into the current workspace.

% Configuration Parameters
if ~exist('configFile','var')
    configFile = 'ConfigDefaults';
    if ~exist(configFile,'file')
        error('Couldnt find the ConfigDefaults file. You can use another file by setting the configFile variable before running this script.\n');
    end
end
fprintf('Loading configuration file: %s \n', configFile);
eval(configFile);

% Camera Parameters
if ~exist('cameraFile','var')
    cameraFile = 'CameraDefaults';
    if ~exist(cameraFile,'file')
        error('Couldnt find the CameraDefaults file. You can use another file by setting the cameraFile variable before running this script.\n');
    end
end
fprintf('Loading camera parameters file: %s\n', cameraFile);
eval(cameraFile);

% Gaze Parameters
if ~exist('gazeFile','var')
    gazeFile = 'GazeDefaults';
    if ~exist(gazeFile,'file')
        error('Couldnt find the GazeDefaults file. You can use another file by setting the gazeFile variable before running this script.\n');
    end
end
fprintf('Loading gaze parameters file: %s\n', gazeFile);
eval(gazeFile);
