timeNow = toc;
if ~configPars.DISPLAY || (configPars.lastDisplayTime + 2 > timeNow)
    return;
end;
configPars.lastDisplayTime = timeNow;

% Display map and robot
figure(10);
colormap(gray(256));
image(oGrid);
hold on;
plot(worldState.rGridPos(2),worldState.rGridPos(1),'g+');

if goal.type == 'e' || goal.type == 'a'
    frontier = goal.frontier;
    fSize = size(frontier);
    for j=1:fSize(1)
        plot(frontier(j,2),frontier(j,1),'b');
    end;
end;

if goal.type == 'e' || goal.type == 'o'
    % Plot path
    plot(goal.path(:,2),goal.path(:,1),'g-');
end;

if goal.type == 'o'
    % Looking back at objects, plot them
    plot(goal.objPositions(:,2),goal.objPositions(:,1),'r.');
end;

drawnow;

mappingPars.mapId = saveMap(mappingPars.mapId,configPars.map_path);

if goal.type == 'o'

    yaw = positionPars.rPose(3);
    R_r = [cos(yaw), -sin(yaw); sin(yaw), cos(yaw)];

    for(i=1:size((mappingPars.objs),1))
        objLocs(i,:) = (R_r*mappingPars.objs(i,1:2)')';
        objLocs(i,:) = objLocs(i,:) + positionPars.rPose(1:2);
    end;
    
    % Plot all the potential objects in blue, and the ones
    % we're looking back at in red
    figure(87);
    colormap(gray(256));
    image(oGrid);
    hold on;
    plot(rGridPos(2),rGridPos(1),'g+');
    objLocs = performSlam('get_gridpos_from_vecpos',objLocs);
    plot(objLocs(:,2),objLocs(:,1),'b.');
    plot(goal.objPositions(:,2),goal.objPositions(:,1),'r.');
    mappingPars.mapId = saveMap(mappingPars.mapId,configPars.map_path);
    drawnow;
end;

