% These are the camera configuration defaults. By default, the RunRobot.m script
% will run this file unless the gazeFile variable is present in the
% workspace when RunRobot is run. If this variable is set, then
% configuration information will be loaded from the file named by the
% gazeFile variable.
%
% In other words, to create your own configuration environment, just copy
% this file to its own filename, Eg: GazeExperiment.m, then set 
% gazeFile = 'GazeExperiment.m' before running RunRobot.m.

% Load predictive map and define memory struct
%load gaze_proto_hires338.mat  % 16000 prototypes from 338 saccades
load gaze_proto_hires600rect.mat  % 16000 prototypes from 600 saccades
gazePars.memory.Ap=Ap;
gazePars.memory.Up=Up;
gazePars.memory.Wa=Wa;
gazePars.memory.Wu=Wu;

% Set parameters for predictive map
gazePars.pars.itype = 4;
gazePars.pars.Nn    = 40;
gazePars.pars.gstd  = 1;
