
% Grab the odometry info from the powerbot, and grab all the
% relevant pose information from the SLAM module.
worldState.speeds   = powerbot('getspeeds');

% Perform SLAM if we're not turning too fast
if (abs(worldState.speeds(3))) < 0.01 && (worldState.speeds(1) < 0.01)
    
    if configPars.PRINTLEVEL >= 5
        fprintf('[executeFrame.m]: Called doSlam()\n');
    end;
    [ worldState.odom worldState.rPose worldState.rGridPos  ] = doSlam(1,1); 

else
    
    worldState.odom     = powerbot('getodom');
    worldState.rPose    = performSlam('get_curvecpos');
    worldState.rGridPos = performSlam('get_curgridpos');
    
end;


