/*
 *  Simple wrapper to Canon camera capture library
 */

#include <stdio.h>
#include <stdlib.h>

void capture_start() {
  printf("Initialising Canon camera...");
  system("echo \"start\ndetach\n\" > capture.cmd\n");
  system("capture <capture.cmd >/dev/null");
  printf("done.\n");
}

#define CMD_BUFSZ 128
void capture_grab(char *fname) {
  printf("Canon camera grab to file %s ...",fname);
  char cmd[CMD_BUFSZ];
  snprintf(cmd,sizeof(char)*CMD_BUFSZ,"echo \"capture %s\ndetach\n\" > capture.cmd\n",fname);
  system(cmd);
  system("capture <capture.cmd >/dev/null");
  printf("done.\n");
}

void capture_stop() {
  printf("Shutting down Canon camera...");
  system("echo \"quit\n\" > capture.cmd\n");
  system("capture <capture.cmd >/dev/null");
  printf("done.\n");
}

void capture_setsize(char *sstr) {
  printf("Setting Canon camera capture size to %s ...",sstr);
  char cmd[CMD_BUFSZ];
  snprintf(cmd,sizeof(char)*CMD_BUFSZ,"echo \"size %s\ndetach\n\" > capture.cmd\n",sstr);
  system(cmd);
  system("capture <capture.cmd >/dev/null");
  printf("done.\n");
}

void capture_setzoom(int zoom) {
  char cmd[CMD_BUFSZ];
  printf("Setting Canon camera zoom to %d ...",zoom);
  snprintf(cmd,sizeof(char)*CMD_BUFSZ,"echo \"zoom %d\ndetach\n\" > capture.cmd\n",zoom);
  system(cmd);
  system("capture <capture.cmd >/dev/null");
  printf("done.\n");
}

void capture_setflash(int flash) {
  char cmd[CMD_BUFSZ];
  const char *setting = flash?"on":"off";
  printf("Setting Canon camera flash to %s ...",setting);
  snprintf(cmd,sizeof(char)*CMD_BUFSZ,"echo \"flash %s\ndetach\n\" > capture.cmd\n",setting);
  system(cmd);
  system("capture <capture.cmd >/dev/null");
  printf("done.\n");
}

int capture_loadimage(char *fname,char **imgptr) {
  FILE *fd;
  char *buf;
  long fsz,num_read;
  fd=fopen(fname,"r");
  printf("Opened file %s.\n",fname);
  fseek(fd,0,SEEK_END);  /* Go to end */
  fsz=ftell(fd);
  fseek(fd,0,SEEK_SET);  /* Go to start */
  buf = (char *)calloc(fsz,sizeof(char));
  num_read=fread(buf,sizeof(char),fsz,fd);
  fclose(fd);
  printf("Closed file.\n");
  imgptr[0]=buf;
  if(num_read != fsz) {
    printf("Read error: num_read=%d file size=%d\n",num_read,fsz);
    return -1;
  } else {
    return fsz;
  }
}

void capture_freeimage(char *img) {
  free(img);
}
