/*
 *  STRING1394 functions
 *
 */
#include <libraw1394/raw1394.h>
#include <libdc1394/dc1394_control.h>
#include "string1394.h"

char *getstr_speed(int speed) {
  static char *speeds[] = {"100","200","400",
			   "800","1600","3200","<?>"};
  if((speed>=SPEED_MIN)&&(speed<=SPEED_MAX))
    return speeds[speed-SPEED_MIN];
  else
    return speeds[NUM_SPEEDS];
}

char *getstr_framerate(int framerate) {
  static char *framerates[] = {"1.875","3.75","7.5","15","30",
			       "60","120","240","<?>"};
  if((framerate>=FRAMERATE_MIN)&&(framerate<=FRAMERATE_MAX))
    return framerates[framerate-FRAMERATE_MIN];
  else
    return framerates[NUM_FRAMERATES];
}

char *getstr_mode(int mode) {
  static char *mode_f0[] = {"160x120_YUV444","320x240_YUV422",
			    "640x480_YUV411","640x480_YUV422",
			    "640x480_RGB","640x480_MONO",
			    "640x480_MONO16","<?>"};
  static char *mode_f1[] = {"800x600_YUV422","800x600_RGB",
			    "800x600_MONO","1024x768_YUV422",
			    "1024x768_RGB","1024x768_MONO",
			    "800x600_MONO16","1024x768_MONO16"};
  static char *mode_f2[] = {"1280x960_YUV422","1280x960_RGB",
			    "1280x960_MONO","1600x1200_YUV422",
			    "1600x1200_RGB","1600x1200_MONO",
			    "1280x960_MONO16","1600x1200_MONO16"};
  static char *mode_f6[] = {"EXIF"};
  static char *mode_f7[] = {"FORMAT7_0","FORMAT7_1","FORMAT7_2",
			    "FORMAT7_3","FORMAT7_4","FORMAT7_5",
			    "FORMAT7_6","FORMAT7_7"};

  if((mode>=MODE_FORMAT0_MIN)&&(mode<=MODE_FORMAT0_MAX))
    return mode_f0[mode-MODE_FORMAT0_MIN];
  if((mode>=MODE_FORMAT1_MIN)&&(mode<=MODE_FORMAT1_MAX))
    return mode_f1[mode-MODE_FORMAT1_MIN];
  if((mode>=MODE_FORMAT2_MIN)&&(mode<=MODE_FORMAT2_MAX))
    return mode_f2[mode-MODE_FORMAT2_MIN];
  if(mode==MODE_EXIF)
    return mode_f6[0];
  if((mode>=MODE_FORMAT7_MIN)&&(mode<=MODE_FORMAT7_MAX))
    return mode_f7[mode-MODE_FORMAT7_MIN];
     
  /* Not recognised */
  return mode_f0[NUM_FORMAT0_MODES];
}

char *getstr_format(int format) {
  int ind=0;
  static char *formats[] = {"VGA_NONCOMPRESSED","SVGA_NONCOMPRESSED_1",
			    "SVGA_NONCOMPRESSED_2","STILL_IMAGE",
			    "SCALABLE_IMAGE_SIZE","<?>"};
  switch(format) {
  case FORMAT_VGA_NONCOMPRESSED:
    ind=0;break;
  case FORMAT_SVGA_NONCOMPRESSED_1:
    ind=1;break;
  case FORMAT_SVGA_NONCOMPRESSED_2:
    ind=2;break;
  case FORMAT_STILL_IMAGE:
    ind=3;break;
  case FORMAT_SCALABLE_IMAGE_SIZE:
    ind=4;break;
  default:
    ind=5;break;
  }
  return formats[ind];
}
