function path = buildGridPath(configPars,parents,start,goal)
% Build a path from start to goal as a series of grid cell
% locations from the parents map returned by gridAStar
%

current = goal;
if configPars.PRINTLEVEL >= 2 && isempty(current)
    fprintf('[buildGridPath.m] Error: no destination given.\n');
end;
if configPars.PRINTLEVEL >= 2 && isempty(start)
    fprintf('[buildGridPath.m] Error: no start given.\n');
end;
if goal(1) > size(parents,1) || goal(2) > size(parents,2)
    fprintf('[buildGridPath.m] Error: goal is not on the parents map.\n');
end;
i=1;
% Store the path backwards from the goal
while(current(1) ~= start(1) || current(2) ~= start(2) )
  path(i,:) = current;
  current = [ parents(current(1),current(2),1) parents(current(1),current(2),2)];
  i = i+1;
end;
path(i,:) = current;

% Simplify the path and reverse it
path = path(1:3:end,:);
path = path(end:-1:1,:);
