function [mappingPars, configPars ] = doRandomWalkBB(endTime,mappingPars,planningPars,cameraPars,configPars,gazePars, init)

logFile = mappingPars.logFile;

% A second random walk function based on movebotTo

fprintf('[doRandomWalk2.m]: Performing Random walk...\n');

% Stop the robot by commanding it to move to the location it's already at
powerbot('movebotTo',powerbot('getodom'));

powerbot('setpos',0, -cameraPars.initialTilt );

%[isSafe objs nxtObjId nTotalPics coverageMap ] = randWalkSafetyCheck(planningPars,cameraPars,configPars);

%if ~randWalkSafetyCheck(planningPars,cameraPars,configPars);
%    return;
%end;

beginRandWalkTime = toc;

currentPose = powerbot('getodom');
prevYaw = currentPose(3)+10*pi/180;

% Record robot positions for plotting
positions = currentPose(1:2);

if init
    howLong = configPars.runTime;
else
    howLong = 10;
end
interest_timeout=0;

while toc < endTime
    
    currentPose = powerbot('getodom');
    yaw = currentPose(3);
    
	if rand > 0.5
		powerbot('movebotTo',currentPose + [ 0 0 rand*pi-pi/2 ] );
	else
			
    %if (abs(thetapp(prevYaw-yaw))<5*pi/180)
    %    turnbotOld(randn*40,configPars);
    %    currentPose = powerbot('getodom');
    %    yaw = currentPose(3);
    %    prevYaw = yaw;
    %end
    
    % First check how far it's safe to move
    
    %min_dist = randWalkSafetyDistance(planningPars,cameraPars,configPars);
            
    % Choose a destination in front of the robot's current position, if
    % possible
    
    %moveDist = min( min_dist - configPars.tableThreshold, configPars.stepSize );
    moveDist = configPars.stepSize;
%     if moveDist <= 0.3
%         
%         % Table was too close, explore the location, then turn
%         %[configPars mappingPars] = exploreLocation(cameraPars,gazePars,mappingPars,configPars,planningPars);        
%         turnbot(90);
%         continue
%     end;
    
    destPose = [ currentPose(1:2)+ moveDist .*[cos(yaw) sin(yaw)] yaw ];
    
    powerbot('movebotTo',destPose);
	end;
    
    beginVFHTime = toc;
    lastRecPosTime = -inf;
    
    while toc < beginVFHTime + configPars.stepTime
        
        [ score nestObj ] = bumblebeeCapture();

        fprintf( '[doRandomWalkBB] evaluated score from BB. Score %g interest_timeout %g toc %g\n', score, interest_timeout, toc );

        if(score > configPars.interestThreshold && toc > interest_timeout)

            fprintf( 'FOUND HIGH SCORE\n' );
            % Perform a blocking stop here.
            [worldState.odom worldState.rPose worldState.rGridPos] = stopBot('blocking','doSlam');
            [configPars mappingPars planningPars] = exploreLocation(cameraPars,gazePars,mappingPars,configPars,planningPars,true);
            interest_timeout = toc+configPars.interestInterval;
            powerbot('setpos',0, -cameraPars.initialTilt );
        end
        
        % Do SLAM once in a while if we're not turning too fast
        
        speeds = powerbot('getspeeds');
        
        if abs(speeds(3)) < 0.3 %(abs(speeds(3))) < 0.1 && (speeds(1) < 0.1)%%&& any(speeds>0.01)
            %doSlam(2,1);
        end;
        
        % Record our position once in a while
        if toc - lastRecPosTime > 0.5
            currentPose = powerbot('getodom');
            positions = [positions; currentPose(1:2)];
            lastRecPosTime = toc;
        end;
    end;
    
    
    % Stop the robot and check for safety
    powerbot('movebotTo',powerbot('getodom'));
    %doSlam(1,true,logFile);
    
    %if ~randWalkSafetyCheck(planningPars,cameraPars,configPars)
    %    return;
    %end;
end;


% if isInitRandWalk
%   % Initial walk, move slower
%   %powerbot('movebot');
%   powerbot('movebot',0.2,10);
% else
%   powerbot('movebot');
% end;

% newPose = initialPose
% while norm(newPose(1:2)-initialPose(1:2)) < 0.1
%     newPose = powerbot('getodom');
% end;
% 
% speeds = powerbot('getspeeds');
% while abs(speeds(1)) > 0.01 || abs(speeds(3)) > 0.01
% %while(1)
%   %fprintf('Speeds are %f, %f. Iteration %d.\n',speeds(1),speeds(3),iter);
%   % Do SLAM once in a while if we're not turning too fast
%   if abs(speeds(3)) < 0.5 %&& any(speeds>0.01)
%     doSlam(1,true,logFile);
%     
%     randWalkSafetyCheck(planningPars,cameraPars,configPars);
%   end;
% 
%   speeds = powerbot('getspeeds')
% end
fprintf('[doRandomWalk2.m]: Done\n');

% Save map of where the robot has gone
gridPositions = performSlam('get_gridpos_from_vecpos',positions);
oGrid = performSlam('get_map');
figure(10);
colormap(gray(256));
image(oGrid);
hold on;
plot(gridPositions(:,2),gridPositions(:,1),'g-');
mappingPars.mapId = saveMap(mappingPars.mapId,configPars.map_path);

