function [ nxtOdom ] = getOdometryCommandFromGridPos( dest, worldState )

% Compute the x,y differences in rPose space
  diff_vecpos = performSlam('get_vecpos_from_gridpos',dest) - worldState.rPose(1:2);
  
% Compute the distance required
  delta_r = norm(diff_vecpos);
  
% Compute the absolute angle in rPose frame
  goal_theta_vecpos = thetapp(atan2(diff_vecpos(2),diff_vecpos(1)));
% Compute the difference in angle in rPose frame  - this equals the angle
% difference we'll want in odometry frame
  delta_theta = thetapp( goal_theta_vecpos - worldState.rPose(3) );
  
% Compute the global odometry frame angle
  goal_theta_odom = worldState.odom(3) + delta_theta;
  
% Use this to generate final global odometry frame x,y,theta
  nxtOdom(1) = worldState.odom(1) + delta_r * cos( goal_theta_odom );
  nxtOdom(2) = worldState.odom(2) + delta_r * sin( goal_theta_odom );
  nxtOdom(3) = goal_theta_odom;
  