#include <time.h>
#include <sys/times.h>
#include <unistd.h>

class FPSProfiler
{
public:

	FPSProfiler( int backlog = 10 )
	{
		this->backlog = backlog;
		start = new clock_t[backlog];
		idx=0;
		clockTick = sysconf( _SC_CLK_TCK );
	}

	~FPSProfiler( )
	{
		delete start;
	}

	void tick( )
	{	
		tms t;
		times( &t );
		start[idx] = t.tms_utime + t.tms_stime;//clock();
		idx = (idx + 1) % backlog;
	}

	float getFPS()
	{
		clock_t beginning = start[ idx ];
		clock_t current = start[ (idx-1+backlog)%backlog ];

		//fprintf( stderr, "Beginning: %g, Current %g. Interval %g.\n", beginning/(float)CLOCKS_PER_SEC, current/(float)CLOCKS_PER_SEC, ((float)current-beginning)/CLOCKS_PER_SEC );
		//fprintf( stderr, "Idx = %d, currentIdx = %d.\n", idx, (idx-1+backlog)%backlog );

		return((float)clockTick*backlog)/(current-beginning);	
		//return ((float)CLOCKS_PER_SEC*backlog)/(current-beginning);	
	}

private:
	int backlog;
	clock_t *start;
	int clockTick;
	int idx;
	tms current;
};
