#ifndef _BUMBLEBEE_H_
#define _BUMBLEBEE_H_

//#define DISPLAY
#define SHM_NAME "/srvc_shm"
#define SHM_SIZE 10*1024*1024
#define SEM_NAME "/srvc_sem"

#define CAMERA_HEIGHT 1.17
#define POSITION_X_OFFSET 0
#define HEIGHT_THRESHOLD 0.1
#define PTU_TILT 30
#define BUF_LEN 50

// Keep these parameters consistent when updating them in the code
#define RAW_WIDTH 1024
#define RAW_HEIGHT 768
#define SALIENCY_LEVEL 3
#define SALIENCY_WIDTH 128
#define SALIENCY_HEIGHT 96

//#define STEREO_FULL_RES 
#ifdef STEREO_FULL_RES 
int stereo_width = 1024;
int stereo_height = 768;
#else
int stereo_width = 320;
int stereo_height = 240;
#endif

//#define PI 3.1415

// MSER Segmentation Related Parameters
#define MSER_INTENSITY_THRESH 3.0
#define MSER_OVERLAP_THRESH 0.3
#define MSER_MAX_REGIONS 10
#define MSER_FOREGROUND_THRESH 0.2

#define DO_STEREO
#define DO_SALIENCY
#define DO_MSER
//#define DO_SIFT_MATCH

#endif // _BUMBLEBEE_H_
