

#ifndef SHARED_MEMORY
#define SHARED_MEMORY

#include <sys/types.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>


class SharedMemory 
{
public:
SharedMemory(char* name, mode_t mode = 0660)
{        
    this->name = name;
    this->mode = mode;
    base = NULL;
    ptr = NULL;
    size = -1;
//      sem = NULL;
}

void* create(int size)
{
    this->size = size;
    /* creating the shared memory object    --  shm_open()  */
    shmfd = shm_open(name, O_RDWR | O_CREAT, mode);
    if (shmfd < 0) {
        perror("In shm_open()");
        exit(1);
    }
    ftruncate(shmfd, size);
    
    map();
    
    return base;
}

void* attach()
{
    /* creating the shared memory object    --  shm_open()  */
    shmfd = shm_open(name, O_RDWR, mode);
    if (shmfd < 0) {
        perror("In shm_open()");
        return NULL;
    }
    
    struct stat buf;
    fstat(shmfd,&buf);
    this->size = buf.st_size;
    
    map();
    
    return base;
}


void detach()
{
    if (base != NULL && size>0) {
        munmap(base,size);   
    }
}

void remove()
{
    shm_unlink(name);
}

void lock()
{
/*      if (sem == NULL) {
    }*/
}


template<typename T>
T* reserve(int count = 1)
{
    int alloc_size = sizeof(T)*count;
    if (size-(ptr-base)>alloc_size) {
        T* tmp = (T*) ptr;
        ptr += alloc_size;
        return tmp;
    }
    else {
        return NULL;
    }
}

void reset()
{
    ptr = base;
}

~SharedMemory() 
{
        detach();
}


private:
    void* map()
    {
        /* requesting the shared segment    --  mmap() */    
        base = (char*)mmap(NULL, size, PROT_READ | PROT_WRITE, MAP_SHARED, shmfd, 0);
        if (base == MAP_FAILED) {
            perror("In mmap()");
            return NULL;
        }
        
        reset();
    }


private:
char* name;

int shmfd;
int size;
mode_t mode;
char* base;
char* ptr;

// semaphore
//sem_t* sem;
};






#endif
