function cPose = rPose2cPose(rPose, position_offset)
% Get the camera pose based on the robot's pose. Assumes that the camera
% position is a constant offset along the direction the robot is facing.
%
% rPose - robot's pose [x y theta]
% position_offset - offset of camera relative to robot
%

yaw = rPose(3);
x = position_offset * cos(yaw);
y = position_offset * sin(yaw);
cPose = [rPose(1)+x rPose(2)+y rPose(3)];

