function [bestAngles bestWedges] = chooseBestAngles(binCentres, visible_regions, wedgeMasks)
% Pick the angles that let us see areas we've had the least coverage.
% This tries to look ahead and plan the topN best angles. The planning is
% no
%

nBins = length(binCentres);
binScores = zeros(1,nBins);

% Pick the topN best angles to explore
topN = 3;

bestAngles = zeros(1,topN);
bestWedges = false([size(wedgeMasks(:,:,1)),topN]);

% Calculate scores
for j=1:nBins
    
    binScores(j) = sum(visible_regions(wedgeMasks(:,:,j)));
end;

nChosen = 0;
while nnz(binScores) && nChosen < topN

    nChosen = nChosen + 1;

    % Pick the best angle
    [sortedScores idx] = sort(binScores,'descend');
    bestAngles(nChosen) =binCentres(idx(1));
    bestWedges(:,:,nChosen) = wedgeMasks(:,:,idx(1));

    % Mark this angle as seen by setting all cells to 0. This discourages
    % choosing another view that overlaps with this one.
    visible_regions(bestWedges(:,:,nChosen)) = 0;

    %     indices = ~bestWedges(:,:,nChosen);
    %     indices = indices & map_region;
    %     visible_regions(indices) = min(visible_regions(indices)+1,255);

    % Recalculate scores
    for j=1:nBins
        binScores(j) = sum(visible_regions(wedgeMasks(:,:,j)));
    end;

end
bestAngles = bestAngles(1:nChosen);
bestWedges = bestWedges(:,:,1:nChosen);

