/* capture.c (c) 2004 Petr Danecek
 * Based on work of Mariusz Woloszyn and Nikolai Kopanygin.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __PTP_UTILS_H__
#define __PTP_UTILS_H__

#include <usb.h>
#include <libptp2/ptp.h>

#include <stdio.h>
#include <string.h>
#include "capture.h"


#define RUN_N_CHK(x) { int stat = (x); if((stat)!=PTP_RC_OK) { \
      error("bad status on %s:%d - %04X\n", __FILE__, __LINE__, stat); \
      return stat; } }

struct usb_device* find_device (int busn, int devn);
int ptp_usb_init(settings_t *settings);
void ptp_usb_close(settings_t *settings);
int magic_code(settings_t *settings);
int ptp_checkevent(settings_t *settings, PTPUSBEventContainer *fill_event);
int usb_checkevent_wait(settings_t *settings);
void find_endpoints(settings_t *settings);
int camera_close(settings_t *settings);
int capture(settings_t *settings, char *file);
int lock_focus(settings_t *settings);
int unlock_focus(settings_t *settings);
int getchanges(settings_t *settings);
int photograph(settings_t *settings);

int set_prop8(settings_t *settings, uint16_t prop, uint8_t val);
int set_prop16(settings_t *settings, uint16_t prop, uint16_t val);
int get_prop16 (settings_t *settings, uint16_t prop, uint16_t *val);
int get_prop32 (settings_t *settings, uint16_t prop, uint32_t *val);

#endif

