%function Im=draw_moments(Im0,mvec,lw)
%
% Visualise a list of moments in a
% grey scale image.
%
% IM0    Bitmap to draw in
% MVEC   Moment list
% LW     Line width for ellipses (default 0.5)
%
% See also PAINT_MASK, and DRAW_ELLIPSE
%
%Per-Erik Forssen, October 2005

function Im=draw_moments(Im0,mvec,lw)

if nargin<3,lw=0.5;end

Im=Im0;

Nbl=size(mvec,2);

for k=1:Nbl,
  m=mvec(2:3,k);
  I=reshape(mvec([4 5 5 6],k),[2 2]);
  Im=draw_ellipse(Im,m,I,lw);
end
