%function Im=paint_mask(Im0,mask,col)
%
% Draw an object defined by the mask MASK
% in RGB image Im0.
%
% IM0    Image to draw in (ROWSxCOLSx3)
% MASK   Object mask (ROWSxCOLS) with range [0,1]
% COL    RGB vector (3x1) default [1 0 0]
%
%Per-Erik Forssen, May 2004
function Im=paint_mask(Im0,mask,col)

if nargin<3,col=[1 0 0];end

[rows,cols,ndim]=size(Im0);

nmask=1-mask;

Im=reshape([Im0(:,:,1).*nmask+mask*col(1) ...
	    Im0(:,:,2).*nmask+mask*col(2) ...
	    Im0(:,:,3).*nmask+mask*col(3)],[rows cols 3]);
