%function h=plot_numbers(mvec,fsz)
%
% Plot blob numbers at centre of
% gravity
%
% MVEC  Moment vector
% FSZ   Font size (default 10)
%
%Per-Erik Forssen, June 2003

function h=plot_numbers(mvec,fsz)

if nargin<2,fsz=10;end

Nbl=size(mvec,2);
h=zeros(Nbl,1);

for k=1:Nbl,
  h(k)=text(mvec(2,k),mvec(3,k),num2str(k));
  set(h(k),'FontSize',fsz);
  set(h(k),'HorizontalAlignment','center');
  set(h(k),'VerticalAlignment','middle');
end

if(nargout==0),clear h;end