%function Im=show_corresp_im(il,ir,pl,pr,lw,lc,mc)
%
% IL,IR   RGB images 
% PL,PR   Point lists of form P=[x(:) y(:)]
% LW      Line Width (default 1.5)
% LC      Line Colour (default [1 0 0])
% MC      Marker Colour (default [0 0 1])
%
%
function Im=show_corresp_im(il,ir,pl,pr,lw,lc,mc)

if nargin<5,lw=1.5;end
if nargin<6,lc=[1 0 0];end
if nargin<7,mc=[0 0 1];end

Im=[il ir];
offset=size(il,2);
mask=zeros(size(Im(:,:,1)));
P1=pl';
P2=[pr(:,1)'+offset ; pr(:,2)'];
mask=draw_lines(mask,P1,P2,lw);
Im=paint_mask(Im,mask,lc);
mask=zeros(size(Im(:,:,1)));
mask=draw_marker(mask,[P1 P2],lw,'o',10);
Im=paint_mask(Im,mask,mc);

