function [q_all times]=classify_image(im, active_features, high_edge, low_edge, high_hist, low_hist, all_bins, all_edges, all_counts, high_counts, low_counts)
    im = double(im);
    
    % Generate image features
    features = [];
    num_features = size(active_features, 2);
    times = [];
    for submode = 1:num_features
        tic
        features = [features ; run_features(im, active_features(submode), high_edge, low_edge, high_hist, low_hist)];
        times = [times toc];
    end
        
    high_p = sum(high_counts(1, :), 2) / sum(all_counts(1, :), 2);
    low_p = sum(low_counts(1, :), 2) / sum(all_counts(1, :), 2);

    % Sort into bins
    for i = 1:size(features, 1)
        edges = all_edges(i,:);
        edges = edges(1:max(find(edges)));
        bin = find(histc(features(i), edges));

        hp = high_counts(i, bin) / all_counts(i, bin);
        lp = low_counts(i, bin) / all_counts(i, bin);

        if hp ~= 0 && hp ~= 1 && lp ~= 0 && lp ~= 1
            high_p = high_p * hp;
            low_p = low_p * lp;
        end
    end
    
    %    sum_p = high_p + low_p;
    %    high_p = high_p / sum_p;
    %    low_p = low_p / sum_p;

    q_all = high_p / low_p;
end