% Based on 'The Design of High-Lebel Features for Quality Assessment' 2006
% 4.2
function hist=color_hist(im)
    hist = zeros(16, 16, 16);

    im = floor(im ./ 16) + 1;

    r = im(:,:,1);

    % Allow for greyscale images, treat as red channel only
    if size(im,3) < 3
        g = ones(size(im,1), size(im,2));
        b = ones(size(im,1), size(im,2));
    else 
        g = im(:,:,2);
        b = im(:,:,3);
    end
    
    r = r(:);
    g = g(:);
    r = b(:);
    
    for x = 1:size(r,1)
        hist(r(x), g(x), b(x)) = hist(r(x), g(x), b(x)) + 1;
    end
    
    hist = hist / sum(hist(:));
end
