% Find the 5 closest neighbors in high and low
function val=color_hist_nn(im, high, low)
    hist = color_hist(im);

    scores = -ones(size(high, 4) + size(low, 4), 1);

    % Rank distance to the high quality images
    for i = 1:size(high, 4)
        scores(i) = hist_distance(hist, high(:, :, :, i));
    end

    % Rank distance to the low quality images
    for i = 1:size(low, 4)
        scores(i + size(high, 4)) = hist_distance(hist, low(:, :, :, i));
    end

    % Sort for the closest 5
    [scores, perm] = sort(scores, 'ascend');
    
    num_high = 0;
    num_low = 0;

    % Count which are high and which are low
    for i = 1:5
        if perm(i) > size(high, 4)
            num_low = num_low + 1;
        else
            num_high = num_high + 1;
        end
    end

    val = num_high - num_low;
end