% Based on 'DETECTING CARTOONS: A CASE STUDY IN AUTOMATIC VIDEO-GENRE
% CLASSIFICATION' 2003 2.3
function hist=edge_direction(im)
    im = mean(im, 3);

    [BW, thresh, e_v, e_h] = edge(im, 'sobel');

    theta = atan(e_v ./ (e_h + (e_h == 0) * eps)) + pi/2;
    m = e_v .* e_v + e_h .* e_h;
    
    hist = zeros(8, 5);
    edges_t = linspace(0, pi, 8);
    edges_m = linspace(0, max(max(m)), 5);
    
    for i = 1:size(im, 1)
        for j = 1:size(im, 2)
            i1 = find(histc(theta(i, j), edges_t));
            i2 = find(histc(m(i, j), edges_m));
            hist(i1, i2) = hist(i1, i2) + 1;
        end
    end
end