% Based on 'The Design of High-Lebel Features for Quality Assessment' 2006
% 4.1
function val=edge_dist(im)
    im = edge_feature(im);

    % Start the bounds at the extremes
    % Start moving each end in, whichever side has lowest energy for each
    % step
    % Stop when neither end can move in without bringing the energy bounded
    % under 98%
    area = 1;
    for dim = [1,2]
        p = sum(im, dim);
        b1 = 1;
        b2 = 100;
        while 1
            if p(b1) > p(b2) && sum(p(b1:b2-1)) > 0.98
                b2 = b2 - 1;
            elseif sum(p(b1+1:b2)) > 0.98
                b1 = b1 + 1;
            else
                area = area * (b2 - b1) / 100;
                break;
            end
        end
    end
    
    val = 1 - area;
end