% Based on 'Estimating the photorealism of images: Distinguishing paintings from
% photographs' 2003 2.1.1
function val=edge_type(im)
    % All intensity edges
    e1 = edge(mean(im, 3), 'canny');

    % Just the color edges
    e2 = zeros(size(im, 1), size(im, 2));
    
    total = (sum(im, 3) + (sum(im, 3) == 0));
    
    for dim = 1:size(im, 3)
        % Normalize to remove intensity edges
        a = im(:,:,dim) ./ total;
        e2 = e2 + edge(a, 'canny');
    end

    % Combine all the channels
    e2 = min(e2, 1);

    % Result is the ratio of intensity only edges to all edges
    val = sum((e1(:) - e2(:)) > 0) / sum(e1(:) > 0);
end