function edges=generate_edges(high, low, f, default_size)
    all = [high ; low];

    edges = linspace(min(all(:,f)), max(all(:,f)), default_size);

    % For any bin that has fewer than 10 entries in high or low, combine it
    % with its smallest neighbor
    while 1
        high_c = histc(high(:,f), edges);
        low_c = histc(low(:,f), edges);

        [minH iH] = min(high_c(1:end-1));
        [minL iL] = min(low_c(1:end-1));

        if (minH >= 10) && (minL >= 10) || (size(high, 1) < 10) || (size(low, 1) < 10)
            break;
        end
        
        if (iH < iL)
            n = smallest_neighbor(iH);
        else
            n = smallest_neighbor(iL);
        end
        
        edges = [edges(1:n-1) edges(n+1:end)];
    end

    edges = [edges inf];
    
    function n=smallest_neighbor(i)
        if i == 1
            n = i + 1;
        elseif i == size(high_c, 1)
            n = i - 1;
        elseif high_c(i) + low_c(i) < high_c(i) + low_c(i)
            n = i - 1;
        else
            n = i + 1;
        end
    end
end