% Based on 'Estimating the photorealism of images: Distinguishing paintings from
% photographs' 2003 2.3
function val=grayscale_texture(im)
    addpath simplegabortb-v0.2.2

    % Generate Gabor filter output
    im = mean(im, 3);
    bank = sg_createfilterbank(size(im), 0.6 , 4, 4);
    r = sg_filterwithbank(im, bank, 'method', 1);
    m = sg_resp2samplematrix(r);

    val = [];

    % For each orientation and scale, generate mean and standard dev across
    % the image -- I *think* this is what the paper described, but the
    % vector sizes don't add up
    for i = 1:size(m, 3)
        l = abs(m(:,:,i));
        mu = mean(l(:));
        s = std(l(:));
                
        val = [val mu s];
    end    
end