% Based on 'The Design of High-Lebel Features for Quality Assessment' 2006
% 4.3
function val=hue_count(im)
    % Hue count for greyscale images is 1
    if size(im, 3) == 1
        val = 1;
        return;
    end
    
    im = rgb2hsv(im);
    hist = zeros(20, 1);

    for x = 1:size(im, 1)
        for y = 1:size(im, 2)
            h = im(x, y, 1);
            s = im(x, y, 2);
            v = im(x, y, 3) / 255;
            if v >= 0.15 && v <= 0.95 && s > 0.2
               index = floor(h / 0.05) + 1;
               hist(index) = hist(index) + 1;
            end
        end
    end

    % Threshold results
    m = max(hist);
    count = 0;
    alpha = 0.05;
    
    for x = 1:size(hist,1)
       if hist(x) > alpha * m
           count = count + 1;
       end
    end
    
    val = 20 - count;
end