function [all_bins, all_edges, all_counts, high_counts, low_counts]=process_data(high_data, low_data)
    bin_size = [100 100 6 21 100 100 100];
    bin_size = [bin_size ones(1, size(high_data, 2) - size(bin_size, 2)) * 100];

    all_bins = zeros(size(bin_size, 1), 1);
    all_edges = zeros(size(bin_size, 1), 100);
    all_counts = zeros(size(bin_size, 1), 100);
    high_counts = zeros(size(bin_size, 1), 100);
    low_counts = zeros(size(bin_size, 1), 100);
        
    % For each feature, count high/low for each bin
    for i = 1:size(bin_size, 2)
        fprintf('Feature %d\n', i);
        edges = generate_edges(high_data, low_data, i, bin_size(i));

        high_c = histc(high_data(:,i), edges);
        low_c = histc(low_data(:,i), edges);

        all_bins(i) = size(edges, 2) - 1;

        edges = [edges zeros(1, 100 - size(edges, 2))];
        high_c = [high_c' zeros(1, 100 - size(high_c, 1))];
        low_c = [low_c' zeros(1, 100 - size(low_c, 1))];

        all_edges(i,:) = edges;
        all_counts(i,:) = high_c + low_c;
        high_counts(i,:) = high_c;
        low_counts(i,:) = low_c;
    end
end