% Runs the classifier on each entry in a directory, returning a cell array
% of file names to ratings
function rate_directory(dirname, num_images)
    load classifier_spec_edges
    load classifier_spec_hists
    load classifier_spec_counts

    active_features = 1:7;

    fname = [dirname '/rank.txt'];
    fid = fopen(fname, 'w');
    if fid < 0
        error(['Could not open ', fname, ' for writing']);
    end

    % Rank each image using the classifier
    for i = 1:num_images
      filename = [dirname '/' int2str(i - 1) '.jpg'];   
        if exist(filename, 'file')
             im = double(imread(filename));
             [rank, times] = classify_image(im, active_features, high_edge, low_edge, high_hist, low_hist, all_bins, all_edges, all_counts, high_counts, low_counts);

             fprintf(fid, '%f\n', rank);
        end
    end
    
    fclose(fid);
    
    quit;
end