% A New Feature Selection Score for Multinomial Naive
% Bayes Text Classification Based on KL-Divergence
function val=rate_feature(count_all, count_f)
    val = 1;
    
    C = 2;
    S = sum(count_all);
    p_c_high = sum(count_f) / S;
    p_c_low = (S - sum(count_f)) / S;

    for bin = 1:size(count_all, 1)
        N_high = count_f(bin); % number of images in this bin
        N_low = count_all(bin) - N_high;
        q_w = N_high / S + (N_low) / S; %sum over classes N/S
        
        p_wc_high = (1 + N_high) / (size(count_all, 1) + sum(count_f));
        p_wc_low = (1 + N_low) / (size(count_all, 1) + sum(count_f));
        p_w = p_c_high * p_wc_high + p_c_low * p_wc_low;

        k = -p_w * log(q_w);

        q_wc_high = N_high / sum(count_f);
        q_wc_low = N_low / (S - sum(count_f));

        kl = p_c_high * p_wc_high * log(q_wc_high) + p_c_low * p_wc_low * log(q_wc_low);

        val = val * (k - kl);
    end
end