function val=run_features(im, mode, high_edge, low_edge, high_hist, low_hist)
    switch mode
        case 1
            % Edge distribution 1
            % Elapsed time is 0.105434 seconds.
            val = edge_dist(im);

        case 2
            % Edge distribution 2
            % Elapsed time is 0.108804 seconds.
            val = edge_dist2(im, high_edge, low_edge);

        case 3
            % Color distribution
            % Elapsed time is 1.418854 seconds.
            val = color_hist_nn(im, high_hist, low_hist);

        case 4
            % Hue count
            % Elapsed time is 0.387496 seconds.
            val = hue_count(im);

        case 5
            % Blur
            % Elapsed time is 0.240795 seconds.
            val = blur_measure(im);

        case 6
            % Contrast
            % Elapsed time is 0.541998 seconds.
            val = contrast_dist(im);

        case 7
            % Brightness
            % Elapsed time is 0.350895 seconds.
            val = brightness_dist(im);
 % NOT USED
        case 8
            % Average saturation
            % Elapsed time is 0.360043 seconds.
            val = avg_saturation(im);

        case 9
            % Combined wavelet dists
            % Grayscale texture (gabor filter) -- unsure about implementation
            % Elapsed time is 3/5.9 seconds.
            val = combined_wavelet_dist(im);
            val = val';

        case 10
            % Edge type
            % Elapsed time is 1/5.2 seconds.
            val = edge_type(im);

        case 11
            % Edge direction histogram
            % Elapsed time is 1.6/7.290399 seconds.
            val = edge_direction(im);
            val = val(:);

        case 12
            % Granulometry -- too slow with large scale included
            % Elapsed time is 37.892381 seconds. -- 5.8 / 21 -- 3.5/3.7
            val = granulometry(im);
    end
end