function test_directory(dirname, testname)
    load classifier_spec_edges
    load classifier_spec_hists
    load classifier_spec_counts

    ranks = [];
    indices = [];

    fulldirname = ['images/' dirname];
    files = dir(fulldirname);
    active_features = 1:7;

    all_times = zeros(1, 20);
    
    % Rank each image using the classifier
    for i = 1:size(files, 1)
        if files(i).bytes > 0 && sum(findstr(files(i).name, '.html')) == 0
            files(i).name
             im = double(imread([fulldirname '/' files(i).name]));
             [rank, times] = classify_image(im, active_features, high_edge, low_edge, high_hist, low_hist, all_bins, all_edges, all_counts, high_counts, low_counts);
             
             ranks = [ranks rank];
             indices = [indices i];
 
             all_times = all_times + [times zeros(1, 20 - size(times, 2))];
        end
    end
    
    [ranks, perm] = sort(ranks, 'descend');

    all_times = all_times ./ size(perm, 2);
    
    % Create new HTML file with an inline for each image
    fname = [fulldirname '/' testname '.html'];
    fid = fopen(fname, 'w');
    if fid < 0
        error(['Could not open ', fname, ' for writing']);
    end

    for i = 1:size(perm, 2)
        file = files(indices(perm(i))).name;
        fprintf(fid, '%f: <img src="%s"><br /><br />\n', ranks(i), file);
    end
    fprintf(fid, '<br />\n<br />\n<b>%f</b>:<br />%f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f<br />\n', sum(all_times), all_times);
    
    fclose(fid);
end