import os, sys, re, TargetedWalnet, shutil, getopt, urllib

def hasHBackground(imageFilename):      
        hBackground = os.system("./hbackground " + imageFilename + " 3 100 20 0.2 0.4 ")
        return hBackground

def openAndFilter(nullArg,directory,imageList):

        print directory
        infoFile = open(os.path.join(directory,'imageInfo.txt'),'w')

        for iName in imageList:
                fullName = os.path.join(directory, iName)
                if not os.path.isdir(fullName): 
                        try:
                                #i = Image.open(fullName)
        
                                outName = iName.split(".")
                                num = outName[0]
                                #outName = num + ".ppm"
                                print "Opened " + fullName
                                if hasHBackground(fullName):
                                        infoFile.write(num + ' 1\n')
                                else:
                                        infoFile.write(num + ' 0\n')    
                                #i.save(os.path.join(directory, outName), 'ppm')
                                #os.system("rm -rf " +os.path.join(directory,iName))
                        except IOError:
                                print "Didn't open file " + fullName
                        

def getImagesFromList(listFileName, exeDir, qualityDir, resultDir, numPages, numImagesGoogle, numImagesWalmart):
	listFile = open(listFileName, 'r')
	dirName = 0
	os.mkdir(os.path.join(os.path.join(resultDir,"walnet/")))

	for line in listFile:
		line = line.replace("\"", "")
		line = line.replace("<", "")
		line = line.replace(">", "")

		acceptableChars = "[^a-zA-Z0-9]"

                open(os.path.join(resultDir, "log.xml"),"a").write("<class name=\""+re.sub(acceptableChars,'_',line.strip())+"\">\n")

		line = urllib.quote(line.strip())
                line = "+".join(line.split())
                print line

		# Google Image stuff
                os.chdir(exeDir)
                print "./monofetch.sh %s %s %s %s" % (line, os.path.join(resultDir,"google/")+str(dirName), numPages, numImagesGoogle)
                os.system("./monofetch.sh \"%s\" %s %s %s" % (line, os.path.join(resultDir, "google/")+ str(dirName), numPages, numImagesGoogle))
                os.chdir(homeDir)
		
		# Call the quality ranking code
		os.chdir(qualityDir)
                os.system("matlab -nodisplay -nojvm -nosplash -nodesktop -r \"rate_directory('%s', %s)\"" % (os.path.join(resultDir,"google/")+ str(dirName), numImagesGoogle))
		os.chdir(homeDir)
		
		# Open the ranking output file
                rank = open(os.path.join(resultDir,"google/")+ str(dirName) + "/rank.txt","r")
		
                for n in range(1,TargetedWalnet.numImages(os.path.join(resultDir,"google/")+str(dirName))):
			r = rank.readline().strip()
			open(os.path.join(resultDir,"log.xml"),"a").write("<img path=\"%s/%d.jpg\" source=\"google\" quality=\"%s\" />\n"%(os.path.join(resultDir,"google/")+str(dirName),n-1,r))
		
                # Walnet stuff
                TargetedWalnet.grabWalnetByName(os.path.join(resultDir,"walnet/")+str(dirName),line,numImagesWalmart)

		# Call the quality ranking code
		os.chdir(qualityDir)
                os.system("matlab -nodisplay -nojvm -nosplash -nodesktop -r \"rate_directory('%s', %s)\"" % (os.path.join(resultDir,"walnet/")+ str(dirName), numImagesWalmart))
		os.chdir(homeDir)
		
		# Open the output files
                rank = open(os.path.join(resultDir,"walnet/")+ str(dirName) + "/rank.txt","r")
		weight = open(os.path.join(resultDir,"walnet/")+ str(dirName) + "/weight.txt","r")
		dim = open(os.path.join(resultDir,"walnet/")+ str(dirName) + "/dim.txt","r")
		
                for n in range(1,TargetedWalnet.numImages(os.path.join(resultDir,"walnet/")+str(dirName)) - 2):
			r = rank.readline().strip()
			w = weight.readline().strip()
			d = dim.readline().strip()
			open(os.path.join(resultDir, "log.xml"),"a").write("<img path=\"%s/%d.jpg\" source=\"walnet\" quality=\"%s\" weight=\"%s\" dim=\"%s\" />\n"%(os.path.join(resultDir,"walnet/")+str(dirName),n-1,r,w,d))


                open(os.path.join(resultDir, "log.xml"),"a").write("</class>\n")
                dirName += 1

def usage():
	print "getImages.py";
	print " -h, --help: this message";
	print " -g NUM, --google NUM: Collect NUM images from Google Images. Default: 10";
	print " -w NUM, --walmart NUM: Collect NUM images from Walmart. Default: 10";
	print " -r DIR, --resultdir DIR: Place output in local directory DIR. Default: resultImages";

numPages = 20
numImagesGoogle = 10
numImagesWalmart = 10
resultDir = 'resultImages'

try:
	opts, args = getopt.getopt(sys.argv[1:], "hg:w:r:", ["help", "google=", "walmart=", "resultdir="]);
except getopt.GetoptError, err:
	usage()
	sys.exit()

for o, a in opts:
        if o in ("-h", "--help"):
		usage()
		sys.exit()
        elif o in ("-g", "--google"):
		numImagesGoogle = int(a)
        elif o in ("-w", "--walmart"):
		numImagesWalmart = int(a)
        elif o in ("-r", "--resultdir"):
		resultDir = a
        else:
		assert False, "unhandled option"
	    
homeDir = os.getcwd();
exeDir = os.getcwd() + '/scripts'
qualityDir = os.getcwd() + '/../QualityRank'
#resultImages = os.getcwd() + '/' + resultDir + '/'
resultImages = os.path.abspath(resultDir)
resultDir = os.path.abspath(resultDir)

try:
       	shutil.rmtree(resultImages)
except:
       	pass
nullArg = ""
os.makedirs(resultImages)
open(os.path.join(resultDir,"log.xml"),"w").write("<?xml version=\"1.0\"?>\n<trainingdata>\n")
getImagesFromList("list.txt", exeDir, qualityDir, resultImages, numPages, numImagesGoogle, numImagesWalmart)
open(os.path.join(resultDir,"log.xml"),"a").write("</trainingdata>\n")
donePath = os.path.join(resultDir, 'done')
f = open(donePath,'w')
f.close()
#os.path.walk(resultImages, openAndFilter,nullArg)

