#!/bin/bash



USER_AGENT="Mozilla/5.0 (Macintosh; U; Intel Mac OS X; en-US; rv:1.8.0.7) Gecko/20060909 Firefox/1.5.0.7"

#check for the correct number of arguments
#if it's not 2, then exit with error code and print a usage string
if [ $# -ne 3 ]
then 
    echo "Usage: `basename $0` search_term num_pages dest_file"
    exit 64
fi


SEARCH_TERM=$1
NUM_PAGES=$2
DEST_FILE=$3
NEXT=1
COUNTER=1

#remove old URL file (if any)
rm -f $DEST_FILE

#for each page
while [ $COUNTER -le $NUM_PAGES ]; do

    #perform the google search and get the response, placed in "result.html"
    wget "-nv" "-T" "10" "-t1" "-U" "$USER_AGENT" "-Oresult.html" "http://images.google.ca/images?q=""$SEARCH_TERM""&svnum=10&hl=en&start=""$NEXT""&sa=N"
    
    #pull the image list out of result.html
    #FS = field separator
    #RS = Record separator
    IMAGE_LIST=`gawk 'BEGIN {RS="dyn.Img"; FS="," } {if (NR != 1 ) print $4}' result.html`
    #echo $IMAGE_LIST
    IMAGE_LIST=${IMAGE_LIST//"\""/""}
    #echo $IMAGE_LIST
    
    #DIRECTORY=${SEARCH_TERM//" "/"_"}
    #DIRECTORY=${DIRECTORY//"\""/"_"}
    
    #print the URLs of the images in the Image_URLs.html file
    for IMAGE_URL in $IMAGE_LIST
    do
    	echo $IMAGE_URL >> $DEST_FILE
    done
    
    INCREMENT=`echo $IMAGE_LIST | wc -w`  #count words
    let NEXT=NEXT+INCREMENT				  #increment word count
    let COUNTER=COUNTER+1				  #increment the counter
    rm -f result.html					  #remove the temporary result.html file
done
