function [states zooms sc_tots] = getPanTiltZoom(disp,objects,objLocs,cameraPars,gazePars,configPars)

% Unpack Parameters
memory = gazePars.memory;
pars = gazePars.pars;
bbtocan_scaling = cameraPars.bbtocan_scaling;
res = cameraPars.res;
canon_res = cameraPars.canon_res;
zoom_scaling = cameraPars.zoom_scaling;
ptu_lim = cameraPars.ptu_lim;

sc=3.2;     % Scaling from 320x240 to 1024x768
    
% [pl,pr] = getLRPositions(disp,objects,sc);
    
% Store new states here
states = cell(length(objects),1);

% Get current state
state=powerbot('getpos');

% Get origin to centre%   for x=-5:5
%     for y=-5:5
%       disparity = disp(round(cen_y+y),round(cen_x+x));
%       if disparity < DISP_MAX & disparity > DISP_MIN
%         disparities = [disparities; disparity];
%       end;
%     end;
%   end;
%   disp(round(cen_y), round(cen_x)) = median(disparities);

wc = cameraPars.gazeCenter;
    
% Find the desired states
for m=1:length(objects),
%   kpl=[pl(:,m);0;0];
%   kpr=[pr(:,m);0;0];
% 
%   % Call min value searchlim
%   %state2 = [0 0];
%   %state2 = find_saccade(ptu_lim,state,kpl,kpr,memory,pars,wc);
%   states{m} = state2;
% 
%   if ~isempty(state2)
%       states{m} = state2;
%   else
%   
%       % If find_saccade fails, we can still attempt to look at the object by
%       % exploiting our stereo information, and knowledge of robot's geometry
%       if ~all(objLocs(m,:) == 0)
          [fallbackState valid] = computePanTilt(true,objLocs(m,:),configPars.position_offset,cameraPars,configPars);
          if valid
              states{m} = fallbackState;
          end;
%       end;
      
%   end;

end
    
% Scaling from Bumblebee to current Canon resolution at zoom0 
sc0=bbtocan_scaling(canon_res);   
    
wco=res(canon_res,:)'/2;  % Image centre at current res
    
% Compute the desired zoom:
%
% for each object
% for each possible zoom value
%     sc_tot=sc*sc0*zoom_scaling(zoom+1);  % Total scaling from 320x240 image
%     bbox=centreBoundingBox(objects(m),sc_tot,wco);
%     if upperLeft coord is negative, use previous zoom
    
zooms = zeros(length(objects),1);
sc_tots = sc*sc0*zoom_scaling(1)*ones(length(objects),1);
    
for m=1:length(objects)
     
   for zoom=1:6
      
        sc_tot=sc*sc0*zoom_scaling(zoom+1);
        bbox=centreBoundingBox(objects(m),sc_tot,wco);

        if any(bbox.topLeft < 0 )
            break;
        end
        sc_tots(m)=sc_tot;
        zooms(m) = zoom;
                   
   end;
end;            

% Use the following 3 lines if you want to keep zoom constant
%     zoom=2;      % Should be estimated instead 
%     sc_tot=sc*sc0*zoom_scaling(zoom+1);  % Total scaling from 320x240 image
%     zooms=ones(size(states))*zoom;

